#include <stdio.h>
#include <stdlib.h>

#include "calc.h"

extern int debug;

double *in, *out;

int InitFFT(int N) {
	in=calloc(N,sizeof(double)); out=calloc(N,sizeof(double));
	if (in==NULL || out==NULL) { perror("calc"); return -1; }
	return 0;
}

void realfft (double *,unsigned,double *);

double CalcFFT(int N) {
	extern unsigned char *audio_buffer;
	extern int sample_rate;
	int r;

	register int i,lasti; double norm,maxnorm,ffreq;

	for (i=0; i<N; ++i) in[i]=audio_buffer[i]-128;
	realfft(in,N,out);

#ifdef DEBUG
        printf("%f (dc)\n",out[0]);
        for (i=1; i<(N+1)/2; i++) {
		norm=out[2*i-1]*out[2*i-1]+out[2*i]*out[2*i];
                printf("%f, %f (%u-th harmonic) %f (norm)\n",
			out[2*i-1],out[2*i],i,norm
		);
	}
        if (N%2==0) printf("%f (Nyquist)\n",out[N-1]);
#endif

	ffreq=0.0; maxnorm=0.0; lasti=N-2;

        for (i=1; i<lasti; i+=2) {
		norm=out[i]*out[i]+out[i+1]*out[i+1];
		if (norm>maxnorm) { maxnorm=norm; ffreq=i; }
	}

	if (debug) {
		printf("Maxnorm     : %f\n",maxnorm);
		printf("At i number : %f\n",ffreq);
	}

	if((double) maxnorm == 0.0) return (double) 0.0;
	
	if((double) maxnorm < 1.1) return (double) -1.0;
	r = (int) maxnorm;
	/*if(r < 2) return (double) -1.0;*/
	
	return 2.0*ffreq*(double)sample_rate/(double)N;
}
