#include <stdio.h>
#include <math.h>

#include "note.h"

#define freqA	440.0

static char *note[]={
    "A", "A#", "B", "C", "C#", "D", "D#", "E", "F", "F#", "G", "G#", "A"
};

static char *sign[]={
    "<<<<<", "<<<<", "<<<", "<<", "<", "=", ">", ">>", ">>>", ">>>>", ">>>>>"
};

struct note_type Note(double freq) {
	double a,r; int o,i;
	struct note_type retval;

	a=log(freq/freqA)/log(2.0); o=(int)floor(a); 
	r=(a-o)*12.0; i=(int)rint(r);
	
	sprintf(retval.note, "%2s", note[i]); 
	retval.precision = 5+(int)rint((r-i)*10.0);
	sprintf(retval.old_style,"%6.1f Hz  %5s   %2s   O%2d",
		freq,sign[retval.precision],note[i],o
	);
	
	return retval;
}

